// Encoding: ISO-8859-15
/*
 * DiaSCE is a code editor for C and C++.
 * Copyright (C) 2000  Ander Lozano Prez
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Ander Lozano Prez
 * c/Juan de Gardeazabal 4, 1 D
 * 48004 Bilbao
 * Vizcaya
 * Spain
 *
 * ander1@wanadoo.es
 */

#include "main.h"

//*******************************************************************

/*******************************************************************************
 Esta rutina genera el archivo configure.ac, a partir del cual se genera
 el script configure usando autoconf.
 Devido a los problemas de conpilacion en otras distribuciones distintas
 a debian, el archivo generado es el configure.in
 *******************************************************************************/
void aut_crear_configure_ac(void)
{
	gchar *nombre;
	FILE *archivo;
	gchar *contenido,*tmp;
	gchar *version;
	gchar *lenguaje;
	gchar *libs;
	gchar *libs_usuario;
	gchar *opciones;
	gchar *warnings;
	gchar *srcdir;
	gchar *glade_file;
	gchar *idiomas;
	gint cont;
	gboolean usar_pkg_config;
	gchar *nombre_locale;
	gsize read, written;
	gchar *personal;
	
	DEBUG_MSG(->aut_crear_configure_ac);
	contenido=g_strdup_printf("dnl Process this file with autoconf to produce a configure script.\n");
	tmp=contenido;
	contenido=g_strdup_printf("%s\nAC_INIT\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\nAC_PREREQ(2.50)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\nAC_CONFIG_SRCDIR([configure.ac])\n",tmp);
	g_free(tmp);
	tmp=contenido;
	nombre=pro_ejecutable(LOCALE);
	version=pro_version();
	contenido=g_strdup_printf("%sAM_INIT_AUTOMAKE(%s, %s)\n",tmp,nombre,version);
	g_free(nombre);
	g_free(version);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sAM_CONFIG_HEADER(config.h)\n",tmp);
	g_free(tmp);
	tmp=contenido;

	libs=pro_librerias_lincado();

	contenido=g_strdup_printf("%s\nAC_PROG_INSTALL\n",tmp);
	g_free(tmp);
	tmp=contenido;

	lenguaje=pro_lenguaje();
	switch (lenguaje[0]) {
		case '0':
			contenido=g_strdup_printf("%s\nAC_PROG_CC\n",tmp);
			break;
		case '1':
			contenido=g_strdup_printf("%s\nAC_PROG_CXX\n",tmp);
			break;
	}
	g_free(tmp);
	tmp=contenido;
	switch (lenguaje[0]) {
		case '0':
			contenido=g_strdup_printf("%s\nAC_LANG_C\n",tmp);
			break;
		case '1':
			contenido=g_strdup_printf("%s\nAC_LANG_CPLUSPLUS\n",tmp);
			break;
	}
	g_free(tmp);
	tmp=contenido;

	//with this lines we try to autodetect the sistem type to create specific defines
	contenido=g_strdup_printf("%s\ndnl Try to autodetect system type\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sSYSTEM_TYPE=`( uname -s ) 2>&1`\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%scase $SYSTEM_TYPE in\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sLinux)\n\tUNAME_DEFS=\"-D_LINUX\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sFreeBSD)\n\tUNAME_DEFS=\"-D_FREEBSD\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sNetBSD)\n\tUNAME_DEFS=\"-D_NETBSD\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sBSD/OS)\n\tUNAME_DEFS=\"-D_BSD_OS\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sOpenBSD)\n\tUNAME_DEFS=\"-D_OPENBSD\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sSunOS)\n\tUNAME_DEFS=\"-D_SUNOS\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sQNX)\n\tUNAME_DEFS=\"-D_QNX\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sDarwin)\n\tUNAME_DEFS=\"-D_DARWIN\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sIRIX*)\n\tUNAME_DEFS=\"-D_IRIX\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sHP-UX*)\n\tUNAME_DEFS=\"-D_HP_UX\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s[cC][yY][gG][wW][iI][nN]*)\n\tUNAME_DEFS=\"-D_CYGWIN\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s*)\n\tUNAME_DEFS=\"\"\n\t;;\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sesac\n",tmp);
	g_free(tmp);
	tmp=contenido;

	contenido=g_strdup_printf("%s\ndnl This lines are necesary if the software is going to be ported to FreeBSD\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sif test \"x${SYSTEM_TYPE}\" = \"xFreeBSD\"; then\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tCC=\"$CC -I/usr/local/include\"\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tLDFLAGS=\"$LDFLAGS -L/usr/local/lib\"\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sfi\n",tmp);
	g_free(tmp);
	tmp=contenido;

	if (libs[LGETTEXT]=='1') {
		idiomas=pro_idiomas();
		contenido=g_strdup_printf("%s\ndnl Add the languages wich your aplication supports here.\nALL_LINGUAS=\"%s\"\n",tmp,idiomas);
		g_free(tmp);
		g_free(idiomas);
		tmp=contenido;
		contenido=g_strdup_printf("%sAM_GNU_GETTEXT\n",tmp);
		g_free(tmp);
		tmp=contenido;
		nombre=pro_ejecutable(LOCALE);
		contenido=g_strdup_printf("%sGETTEXT_PACKAGE=%s\n",tmp,nombre);
		g_free(tmp);
		tmp=contenido;
		g_free(nombre);
		contenido=g_strdup_printf("%sAC_SUBST(GETTEXT_PACKAGE)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_DEFINE_UNQUOTED(GETTEXT_PACKAGE,\"$GETTEXT_PACKAGE\",[Package name for gettext])\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}

	contenido=g_strdup_printf("%s\ndnl Set PACKAGE_LOCALE_DIR in config.h.\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sif test \"x${prefix}\" = \"xNONE\"; then\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(PACKAGE_LOCALE_DIR, \"${ac_default_prefix}/${DATADIRNAME}/locale\",This needs a coment)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%selse\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(PACKAGE_LOCALE_DIR, \"${prefix}/${DATADIRNAME}/locale\",This needs a coment)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sfi\n",tmp);
	g_free(tmp);
	tmp=contenido;
	
	if ((libs[LGNOME2]=='1') || (libs[LGTK2]=='1') || (libs[LGTK_X112])) {
		contenido=g_strdup_printf("%s\ndnl Set PREFIX in config.h.\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_DEFINE(PREFIX, \"${prefix}\",This needs a coment)\n",tmp);
		g_free(tmp);
		tmp=contenido;

		contenido=g_strdup_printf("%s\ndnl Set SYSCONFDIR in config.h.\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_DEFINE(SYSCONFDIR, \"${sysconfdir}\",This needs a coment)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		
		contenido=g_strdup_printf("%s\ndnl Set DATADIR in config.h.\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_DEFINE(DATADIR, \"${datadir}\",This needs a coment)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		
		contenido=g_strdup_printf("%s\ndnl Set LIBDIR in config.h.\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_DEFINE(LIBDIR, \"${libdir}\",This needs a coment)\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}
	
	contenido=g_strdup_printf("%s\ndnl Subst PACKAGE_PIXMAPS_DIR and set it in config.h.\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sif test \"x${prefix}\" = \"xNONE\"; then\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(PACKAGE_PIXMAPS_DIR, \"${ac_default_prefix}/share/pixmaps/${PACKAGE}\",This is the path where pixmaps will be instaled)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tPACKAGE_PIXMAPS_DIR=\"${ac_default_prefix}/share/pixmaps/${PACKAGE}\"\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%selse\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(PACKAGE_PIXMAPS_DIR, \"${prefix}/share/pixmaps/${PACKAGE}\",This is the path where pixmaps will be instaled)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tPACKAGE_PIXMAPS_DIR=\"${prefix}/share/pixmaps/${PACKAGE}\"\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sfi\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sAC_SUBST(PACKAGE_PIXMAPS_DIR)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	
	contenido=g_strdup_printf("%s\ndnl Subst PACKAGE_DATA_DIR and set it in config.h.\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sif test \"x${prefix}\" = \"xNONE\"; then\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(PACKAGE_DATA_DIR, \"${ac_default_prefix}/share/${PACKAGE}\",This is the path where data will be instaled)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tPACKAGE_DATA_DIR=\"${ac_default_prefix}/share/${PACKAGE}\"\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%selse\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(PACKAGE_DATA_DIR, \"${prefix}/share/${PACKAGE}\",This is the path where data will be instaled)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tPACKAGE_DATA_DIR=\"${prefix}/share/${PACKAGE}\"\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sfi\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sAC_SUBST(PACKAGE_DATA_DIR)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	
	contenido=g_strdup_printf("%s\ndnl Subst PACKAGE_DOC_DIR and set it in config.h.\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sif test \"x${prefix}\" = \"xNONE\"; then\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(PACKAGE_DOC_DIR, \"${ac_default_prefix}/share/doc/${PACKAGE}\",This is the path where docs will be instaled)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tPACKAGE_DOC_DIR=\"${ac_default_prefix}/share/doc/${PACKAGE}\"\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%selse\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(PACKAGE_DOC_DIR, \"${prefix}/share/doc/${PACKAGE}\",This is the path where docs will be instaled)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tPACKAGE_DOC_DIR=\"${prefix}/share/doc/${PACKAGE}\"\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sfi\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%sAC_SUBST(PACKAGE_DOC_DIR)\n",tmp);
	g_free(tmp);
	tmp=contenido;

	if (libs[LLIBGLADE2]=='1') {
		glade_file=pro_glade_file(LOCALE);
		if (glade_file!=NULL) {
			contenido=g_strdup_printf("%s\ndnl Set GLADE_PROJECT in config.h.\n",tmp);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%sif test \"x${prefix}\" = \"xNONE\"; then\n",tmp);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(GLADE_PROJECT, \"${ac_default_prefix}/share/${PACKAGE}/%s\",This is the path where the glade proyect file will be instaled including the file name)\n",tmp,glade_file);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%selse\n",tmp);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\tAC_DEFINE_UNQUOTED(GLADE_PROJECT, \"${prefix}/share/${PACKAGE}/%s\",This is the path where the glade proyect file will be instaled including the file name)\n",tmp,glade_file);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%sfi\n",tmp);
			g_free(tmp);
			tmp=contenido;
		}
		g_free(glade_file);
	}

	// know we add the code that will autodetect the cpu and add specific optimizations
	if (pro_cpu_autodetect()) {
		contenido=g_strdup_printf("%s\ndnl Try to autodetect cpu type\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sCPU_NAME=\"unknown\"\n",tmp);
		g_free(tmp); 
		tmp=contenido;
		contenido=g_strdup_printf("%sCPU_TYPE=\"unknown\"\n",tmp);
		g_free(tmp); 
		tmp=contenido;
		contenido=g_strdup_printf("%sif test -e \"/proc/cpuinfo\" ; then\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[30]]=\"-march=i386\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[32]]=\"-march=i386\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[34]]=\"-march=i386\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[40]]=\"-march=i486\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[41]]=\"-march=i486\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[42]]=\"-march=i486\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[43]]=\"-march=i486\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[44]]=\"-march=i486\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[45]]=\"-march=i486\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[47]]=\"-march=i486\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[48]]=\"-march=i486\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[51]]=\"-march=pentium\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[52]]=\"-march=pentium\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[54]]=\"-march=pentium-mmx\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[61]]=\"-march=pentiumpro\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[63]]=\"-march=pentium2\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[65]]=\"-march=pentium2\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[66]]=\"-march=pentium2\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[67]]=\"-march=pentium3\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[68]]=\"-march=pentium3\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[610]]=\"-march=pentium3\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[611]]=\"-march=pentium3\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[150]]=\"-march=pentium4\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[151]]=\"-march=pentium4\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tintel[[152]]=\"-march=pentium4\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[50]]=\"-march=i586\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[51]]=\"-march=i586\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[52]]=\"-march=i586\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[53]]=\"-march=i586\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[56]]=\"-march=k6\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[57]]=\"-march=k6\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[58]]=\"-march=k6-2\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[59]]=\"-march=k6-3\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[61]]=\"-march=athlon\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[62]]=\"-march=athlon\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[63]]=\"-march=athlon\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[64]]=\"-march=athlon\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[66]]=\"-march=athlon\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[67]]=\"-march=athlon\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tamd[[68]]=\"-march=athlon\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_TYPE=\"known\"\n",tmp);
		g_free(tmp); 
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_FAMILY=`cat /proc/cpuinfo | grep \"cpu family\"`\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_MODEL=`cat /proc/cpuinfo | grep model[[^\\ ]]`\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_NAME=`cat /proc/cpuinfo | grep \"model name\"`\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_FLAGS=`cat /proc/cpuinfo | grep \"flags\"`\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_VENDOR=`cat /proc/cpuinfo | grep \"vendor_id\"`\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_FAMILY=${CPU_FAMILY#'cpu family\t: '}\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_MODEL=${CPU_MODEL#'model\t\t: '}\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_NAME=${CPU_NAME#'model name\t: '}\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_FLAGS=${CPU_FLAGS#'flags\t\t: '}\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_VENDOR=${CPU_VENDOR#'vendor_id\t: '}\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tif test \"x${CPU_VENDOR}\" = \"xGenuineIntel\" ; then\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tCPU_OPTIONS=${intel[[$CPU_FAMILY$CPU_MODEL]]}\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tfi\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tif test \"x${CPU_VENDOR}\" = \"xAuthenticAMD\" ; then\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tCPU_OPTIONS=${amd[[$CPU_FAMILY$CPU_MODEL]]}\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tfi\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tif test \"x${CPU_OPTIONS}\" = \"x\" ; then\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tCPU_TYPE=\"unknown\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tfi\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_EXT=\"\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tfor i in $CPU_FLAGS ; do\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tcase $i in\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tfpu)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\tCPU_FPU=\"-mfpmath=387\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tmmx)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\tCPU_EXT=\"$CPU_EXT -mmmx\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tsse)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\tCPU_FPU=\"-mfpmath=sse -msse\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tsse2)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\tCPU_FPU=\"-mfpmath=sse -msse2\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t3dnow)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\tCPU_EXT=\"$CPU_EXT -m3dnow\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tesac\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tdone\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_OPTIONS=\"$CPU_OPTIONS $CPU_FPU $CPU_EXT\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sfi\n",tmp);
		g_free(tmp);
		tmp=contenido;
		// if the /proc/cpuinfo file didn't work we try with uname
		contenido=g_strdup_printf("%sif test \"x${CPU_TYPE}\" = \"xunknown\"; then\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tCPU_TYPE=`( uname -p ) 2>&1`\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tcase $CPU_TYPE in\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\ti386)\n\t\tCPU_OPTIONS=\"-march=i386\"\n\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\ti486)\n\t\tCPU_OPTIONS=\"-march=i486\"\n\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tPentium2)\n\t\tCPU_OPTIONS=\"-march=pentium2\"\n\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tPentiumpro)\n\t\tCPU_OPTIONS=\"-march=pentiumpro\"\n\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tPentium*)\n\t\tCPU_OPTIONS=\"-march=pentium\"\n\t\t;;\n",tmp); // Pentium
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tk6)\n\t\tCPU_OPTIONS=\"-march=k6\"\n\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tk6-2)\n\t\tCPU_OPTIONS=\"-march=k6-2\"\n\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tk6-3)\n\t\tCPU_OPTIONS=\"-march=k6-3\"\n\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t*)\n\t\tCPU_OPTIONS=\"\"\n\t\tCPU_TYPE=\"unknown\"\n\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tesac\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tif test \"x${CPU_TYPE}\" = \"xunknown\"; then\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tCPU_TYPE=`( uname -m ) 2>&1`\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tcase $CPU_TYPE in\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\ti386)\n\t\t\tCPU_OPTIONS=\"-march=i386\"\n\t\t\t;;\n",tmp); // 386 DX, 386 SX, 386 CX, 386 EX, 386 SL
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\ti486)\n\t\t\tCPU_OPTIONS=\"-march=i486\"\n\t\t\t;;\n",tmp); // 486 DX, 486 SX, 487, 486 DX2, 486 DX4, 486 SX2, 486 SL 
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\ti586)\n\t\t\tCPU_OPTIONS=\"-march=i586\"\n\t\t\t;;\n",tmp); // Pentium, Pentium MMX, AMD-K6, AMD-K6 II, AMD-K6 III
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\ti686)\n\t\t\tCPU_OPTIONS=\"-march=i686\"\n\t\t\t;;\n",tmp); // AMD Athlon, AMD Athlon 4, AMD Athlon XP, AMD Athlon MP, Pentium III (Coppermine), Pentium IV
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tPentium2)\n\t\t\tCPU_OPTIONS=\"-march=pentium2\"\n\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tPentiumpro)\n\t\t\tCPU_OPTIONS=\"-march=pentiumpro\"\n\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tk6)\n\t\t\tCPU_OPTIONS=\"-march=k6\"\n\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tk6-2)\n\t\t\tCPU_OPTIONS=\"-march=k6-2\"\n\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tk6-3)\n\t\t\tCPU_OPTIONS=\"-march=k6-3\"\n\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\t*)\n\t\t\tCPU_OPTIONS=\"\"\n\t\t\t;;\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\t\tesac\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\tfi\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sfi\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%secho \"Detected CPU: $CPU_NAME\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sdnl Now we check if the compiler supports the detected cpu\n",tmp);
		g_free(tmp);
		tmp=contenido;
		switch (lenguaje[0]) {
			case '0':
				contenido=g_strdup_printf("%sCOMPILER=$CC\n",tmp);
				break;
			case '1':
				contenido=g_strdup_printf("%sCOMPILER=$CXX\n",tmp);
				break;
		}
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sfor I in \"$TMPDIR\" \"$TEMPDIR\" \"/tmp\" ; do\n\ttest \"$I\" && break\ndone\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sTMPC=\"$I/cpu_test-$RANDOM-$$.c\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sTMPO=\"$I/cpu_test-$RANDOM-$$.o\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%scat > $TMPC << EOF\nint main(void) { return 0; }\nEOF\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s( $COMPILER $CPU_OPTIONS -o $TMPO $TMPC ) 2>&1\nTMP=\"$?\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%srm -f $TMPO\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%srm -f $TMPC\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sif test \"x${TMP}\" = \"x1\" ; then\n\tCPU_OPTIONS=\"\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\techo \"No CPU optimizations will be added\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%selse\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\techo \"CPU optimization: $CPU_OPTIONS\"\nfi\n",tmp);
		g_free(tmp);
		tmp=contenido;
	} else {
		contenido=g_strdup_printf("%s\nCPU_OPTIONS=\"\"\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}
	
	opciones=pro_opciones_cflags();
	warnings=pro_warnings();
	switch (lenguaje[0]) {
		case '0':
			contenido=g_strdup_printf("%s\nCFLAGS=\"$UNAME_DEFS %s $CPU_OPTIONS %s\"\n",tmp,opciones,warnings);
			break;
		case '1':
			contenido=g_strdup_printf("%s\nCXXFLAGS=\"$UNAME_DEFS %s $CPU_OPTIONS %s\"\n",tmp,opciones,warnings);
			break;
	}
	g_free(tmp);
	g_free(opciones);
	g_free(warnings);
	tmp=contenido;
	
	contenido=g_strdup_printf("%s\ndnl Setting necessary CFLAGS for libs.\n",tmp);
	g_free(tmp);
	tmp=contenido;
	for (cont=0;cont<LGLIB2;cont++) {
		if ((libs[cont]=='1') && (preferencias.inc[cont]!=NULL) && (pro_nombre_librerias_autoconf[cont]!=NULL)) {
			contenido=g_strdup_printf("%s%s_INC=\"%s\"\nAC_SUBST(%s_INC)\n",tmp,pro_nombre_librerias_autoconf[cont],preferencias.inc[cont],pro_nombre_librerias_autoconf[cont]);
			g_free(tmp);
			tmp=contenido;
		}
	}
	usar_pkg_config=FALSE;
	for (cont=LGLIB2;cont<LTOTALES;cont++) {
		if (libs[cont]=='1') {
			usar_pkg_config=TRUE;
		}
	}
	if (usar_pkg_config) {

		contenido=g_strdup_printf("%spkg_modules=\"",tmp);
		g_free(tmp);
		tmp=contenido;
		for (cont=LGLIB2;cont<LTOTALES;cont++) {
			if ((libs[cont]=='1') && (preferencias.inc[cont]!=NULL) && (pro_nombre_librerias_autoconf[cont]!=NULL)) {
				contenido=g_strdup_printf("%s %s",tmp,pro_nombre_librerias[cont]);
				g_free(tmp);
				tmp=contenido;
			}
		}
		contenido=g_strdup_printf("%s\"\nPKG_CHECK_MODULES(PACKAGE, [$pkg_modules])\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_SUBST(PACKAGE_CFLAGS)\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}

	contenido=g_strdup_printf("%s\ndnl Looking for libraries.\n",tmp);
	g_free(tmp);
	tmp=contenido;
	if (usar_pkg_config) {
		contenido=g_strdup_printf("%sAC_SUBST(PACKAGE_LIBS)\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}
	if (libs[LX11]=='1') {
		if (preferencias.lib[LX11]!=NULL) {
			contenido=g_strdup_printf("%sLIBS=\"%s $LIBS\"\n",tmp,preferencias.lib[LX11]);
			g_free(tmp);
			tmp=contenido;
		}
		contenido=g_strdup_printf("%sAC_CHECK_LIB(ICE,main)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_CHECK_LIB(SM,main)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_CHECK_LIB(Xext,main)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_CHECK_LIB(X11,main)\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sAC_CHECK_LIB(Xi,main)\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}
	libs_usuario=pro_librerias_usuario();
	if (libs_usuario!=NULL) {
		contenido=g_strdup_printf("%s%s\nUSER_LIB=\"\"\n",tmp,libs_usuario);
		g_free(tmp);
		tmp=contenido;
		g_free(libs_usuario);
		contenido=g_strdup_printf("%sfor i in $USER_LIBS ; do\n\tcase $i in \n\t\t-l*) USER_LIB=\"$i $USER_LIB\" ;;\n\t\t-L*) LIBS=\"$LIBS $i\" ;;\n\t\t*) LIBS=\"$i $LIBS\" ;;\n\tesac\ndone\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%sfor i in $USER_LIB ; do\n\tj=${i#'-l'}\n\tAC_CHECK_LIB($j,main)\ndone\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}
	if (libs[LELECTRIC_FENCE]=='1') {
		if (preferencias.lib_electric_fence!=NULL) {
			contenido=g_strdup_printf("%sLIBS=\"$LIBS %s\"\n",tmp,preferencias.lib_electric_fence);
			g_free(tmp);
			tmp=contenido;
		}
		contenido=g_strdup_printf("%sAC_CHECK_LIB(efence,main)\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}
	
	personal=pro_configure_ac(LOCALE);
	if (personal!=NULL) {
		contenido=g_strdup_printf("%s\ndnl personalized section\n",tmp);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\n%s\n",tmp,personal);
		g_free(tmp);
		tmp=contenido;
		contenido=g_strdup_printf("%s\ndnl end of personalized section\n",tmp);
		g_free(tmp);
		tmp=contenido;
		g_free(personal);
	}
	
	contenido=g_strdup_printf("%s\nAC_CONFIG_FILES([\nMakefile\n",tmp);
	g_free(tmp);
	tmp=contenido;
	srcdir=pro_srcdir(LOCALE);
	contenido=g_strdup_printf("%s%s/Makefile\n",tmp,srcdir);
	g_free(tmp);
	g_free(srcdir);
	tmp=contenido;
	if (libs[LGETTEXT]=='1') {
		contenido=g_strdup_printf("%spo/Makefile.in\nintl/Makefile\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}
	contenido=g_strdup_printf("%s])\nAC_OUTPUT\n",tmp);
	g_free(tmp);
	tmp=contenido;
	
	nombre=pro_nombre_completo_archivo("configure.ac",FALSE, LOCALE);
	archivo=fopen(nombre,"w");
	fwrite(contenido,strlen(contenido),1,archivo);
	fclose(archivo);
	g_free(nombre);
	g_free(contenido);
	g_free(libs);
	g_free(lenguaje);
	nombre=pro_nombre_completo_archivo("configure.in",FALSE, UTF8);
	if (gen_existe_fichero(nombre)) {
		nombre_locale = g_locale_from_utf8(nombre, -1, &read, &written, NULL);
		remove(nombre_locale);
		g_free(nombre_locale);
	}
	g_free(nombre);
	autoconfiguracion=autoconfiguracion | AUTO_CONF;

	DEBUG_MSG(->aut_crear_configure_ac);
}

/*******************************************************************************
 Esta funcion genera el Makefile.am que hay en la carpeta de las fuentes
 *******************************************************************************/
void aut_crear_makefile_src(void)
{
	FILE *archivo;
	gchar *nombre;
	gchar *contenido,*tmp,*siguiente;
	gint cont;
	xmlNodePtr nodo;
	gchar *includes;
	gchar *libs;
	gchar *srcdir,*prodir;
	gboolean usar_pkg_config;
	
	DEBUG_MSG(->aut_crear_makefile_src);
	contenido=g_strdup_printf("## Process this file with automake to produce Makefile.in\n");
	tmp=contenido;
	contenido=g_strdup_printf("%s\nINCLUDES=",tmp);
	g_free(tmp);
	tmp=contenido;
	libs=pro_librerias_lincado();
	for (cont=0;cont<LGLIB2;cont++) {
		if ((libs[cont]=='1') && (preferencias.inc[cont]!=NULL) && (pro_nombre_librerias_autoconf[cont]!=NULL)) {
			contenido=g_strdup_printf("%s @%s_INC@",tmp,pro_nombre_librerias_autoconf[cont]);
			g_free(tmp);
			tmp=contenido;
		}
	}
	usar_pkg_config=FALSE;
	for (cont=LGLIB2;cont<LTOTALES;cont++) {
		if (libs[cont]=='1') {
			usar_pkg_config=TRUE;
		}
	}
	if (usar_pkg_config) {
		contenido=g_strdup_printf("%s @PACKAGE_CFLAGS@",tmp);
		g_free(tmp);
		tmp=contenido;
	}
	includes=pro_includes();
	if (includes!=NULL) {
		contenido=g_strdup_printf("%s %s",tmp,includes);
		g_free(tmp);
		tmp=contenido;
	}
	contenido=g_strdup_printf("%s -I/usr/include",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\n",tmp);
	g_free(tmp);
	tmp=contenido;
	nombre=pro_ejecutable(LOCALE);
	contenido=g_strdup_printf("%s\nbin_PROGRAMS = %s\n",tmp,nombre);
	g_free(tmp);
	tmp=contenido;
	if (usar_pkg_config) {
		contenido=g_strdup_printf("%s\n%s_LDADD = @PACKAGE_LIBS@\n",tmp,nombre);
		g_free(tmp);
		tmp=contenido;
	}
	contenido=g_strdup_printf("%s\n%s_SOURCES = \\\n",tmp,nombre);
	g_free(tmp);
	tmp=contenido;
	g_free(nombre);
	nodo=NULL;
	do {
		siguiente=pro_cabeceras(&nodo, LOCALE);
		if (siguiente!=NULL) {
			contenido=g_strdup_printf("%s\t%s \\\n",tmp,siguiente);
			g_free(siguiente);
			g_free(tmp);
			tmp=contenido;
		}
	} while (siguiente!=NULL);
	nodo=NULL;
	do {
		siguiente=pro_fuentes(&nodo, LOCALE);
		if (siguiente!=NULL) {
			contenido=g_strdup_printf("%s\t%s \\\n",tmp,siguiente);
			g_free(siguiente);
			g_free(tmp);
			tmp=contenido;
		}
	} while (siguiente!=NULL);
	for (cont=0;contenido[cont]!=0;cont++);
	for (;contenido[cont]!='\\';cont--);
	contenido[cont]=' ';
	contenido[cont+1]=0;
	prodir=pro_prodir(LOCALE);
	srcdir=pro_srcdir(LOCALE);
	nombre=g_strdup_printf("%s/%s/Makefile.am",prodir,srcdir);
	g_free(prodir);
	g_free(srcdir);
	archivo=fopen(nombre,"w");
	fwrite(contenido,strlen(contenido),1,archivo);
	fclose(archivo);
	g_free(nombre);
	g_free(contenido);
	g_free(libs);
	autoconfiguracion=autoconfiguracion | AUTO_MAKE;

	DEBUG_MSG(<-aut_crear_makefile_src);
}

/*******************************************************************************
 Esta funcion genera el Makefile.am que hay en el directorio raiz del proyecto
 *******************************************************************************/
void aut_crear_makefile(void)
{
	FILE *archivo;
	gchar *nombre;
	gchar *contenido,*tmp;
	gchar *srcdir;
	gint cont;
	gchar *libs;
	gchar *pixdir;
	gchar *datadir;
	gchar *docdir;
	gchar *glade_file;
	gchar *extra_files,*extra_tmp;
	gboolean extra;
	
	DEBUG_MSG(->aut_crear_makefile);
	contenido=g_strdup_printf("## Process this file with automake to produce Makefile.in\n");
	tmp=contenido;
	srcdir=pro_srcdir(LOCALE);
	contenido=g_strdup_printf("%s\nSUBDIRS = %s\n",tmp,srcdir);
	g_free(tmp);
	tmp=contenido;
	libs=pro_librerias_lincado();
	if (libs[LGETTEXT]=='1') {
		for (cont=0;contenido[cont]!=0;cont++);
		contenido[cont-1]=0;

		contenido=g_strdup_printf("%s intl po\n",tmp);
		g_free(tmp);
		tmp=contenido;
	}

	if ((libs[LGNOME2]=='1') || (libs[LGTK2]=='1') || (libs[LGTK_X112])) {
		extra_files=g_strdup("\n## Add extra files that sould be included in the distribution.\nEXTRA_DIST =");
		extra_tmp=extra_files;
		extra=FALSE;
		glade_file=pro_glade_file(LOCALE);
		if (glade_file!=NULL) {
			extra=TRUE;
			extra_files=g_strdup_printf("%s %s %sp",extra_tmp,glade_file,glade_file);
			g_free(extra_tmp);
			extra_tmp=extra_files;
			g_free(glade_file);
		}
		if ((libs[LLIBGLADE2]=='1') && (libs[LGETTEXT]=='1')) {
			extra_files=g_strdup_printf("%s %s/translatable_strings_file.c",extra_tmp,srcdir);
			g_free(extra_tmp);
			extra_tmp=extra_files;
		}
		extra_files=g_strdup_printf("%s\n",extra_tmp);
		g_free(extra_tmp);
		extra_tmp=extra_files;
		
		if (extra) {
			contenido=g_strdup_printf("%s%s",tmp,extra_files);
			g_free(tmp);
			tmp=contenido;
		}
		g_free(extra_files);
	}
	
	pixdir=pro_pixdir(LOCALE);
	datadir=pro_datadir(LOCALE);
	docdir=pro_docdir(LOCALE);
	// here we add instruction to install the pixmaps, data and docs directorys
	contenido=g_strdup_printf("%s\ninstall-data-local:\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t@$(NORMAL_INSTALL)\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfunction strlen_diasce {\\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\teval echo \"\\$${#$${1}}\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t}; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfunction es_cvs_diasce {\\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\ttemporal=$$1; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tlongitud=\"$$(strlen_diasce temporal)\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tlet longitud=longitud-4; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tcadena=$${temporal:longitud}; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tif [ \"x$$cadena\" = \"x/CVS\" ] ; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\treturn 0; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\telse \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\treturn 1; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfi; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t}; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfunction subdirs_diasce {\\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\ttemporal=$$3; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tlongitud=\"$$(strlen_diasce temporal)\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfor doc in $$1/*; do \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tif test -f $$doc; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tdestino=\"$$2$${1:longitud}\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t$(INSTALL_DATA) $$doc $$destino; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfi; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tif test -d $$doc; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tif ! (es_cvs_diasce $$doc); then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\tdestino=\"$$2$${doc:longitud}\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\t$(mkinstalldirs) $$destino; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\tsubdirs_diasce $$doc $$2 $$3; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tdone; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t}; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	// first the pixmaps directorie
	contenido=g_strdup_printf("%s\tif test -d $(srcdir)/%s; then \\\n",tmp,pixdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tif test \"x${prefix}\" = \"xNONE\"; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t$(mkinstalldirs) $(DESTDIR)@PACKAGE_PIXMAPS_DIR@; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfor pixmap in $(srcdir)/%s/*; do \\\n",tmp,pixdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tif test -f $$pixmap; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\t$(INSTALL_DATA) $$pixmap $(DESTDIR)@PACKAGE_PIXMAPS_DIR@; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tdone \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\telse \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t$(mkinstalldirs) $(DESTDIR)$(prefix)/share/pixmaps/$(PACKAGE); \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfor pixmap in $(srcdir)/%s/*; do \\\n",tmp,pixdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tif test -f $$pixmap; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\t$(INSTALL_DATA) $$pixmap $(DESTDIR)$(prefix)/share/pixmaps/$(PACKAGE); \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tdone \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfi; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	// second the data directorie
	contenido=g_strdup_printf("%s\tif test -d $(srcdir)/%s; then \\\n",tmp,datadir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tif test \"x${prefix}\" = \"xNONE\"; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t$(mkinstalldirs) $(DESTDIR)@PACKAGE_DATA_DIR@; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfor data in $(srcdir)/%s/*; do \\\n",tmp,datadir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tif test -f $$data; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\t$(INSTALL_DATA) $$data $(DESTDIR)@PACKAGE_DATA_DIR@; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tdone \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\telse \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t$(mkinstalldirs) $(DESTDIR)$(prefix)/share/$(PACKAGE); \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfor data in $(srcdir)/%s/*; do \\\n",tmp,datadir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tif test -f $$data; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\t$(INSTALL_DATA) $$data $(DESTDIR)$(prefix)/share/$(PACKAGE); \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tdone \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfi; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	// third the doc directorie
	contenido=g_strdup_printf("%s\tif test -d $(srcdir)/%s; then \\\n",tmp,docdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tif test \"x${prefix}\" = \"xNONE\"; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t$(mkinstalldirs) $(DESTDIR)@PACKAGE_DOC_DIR@; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tsubdirs_diasce $(srcdir)/%s $(DESTDIR)@PACKAGE_DOC_DIR@ $(srcdir)/%s;\\\n",tmp,docdir,docdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\telse \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t$(mkinstalldirs) $(DESTDIR)$(prefix)/share/doc/$(PACKAGE); \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tsubdirs_diasce $(srcdir)/%s $(DESTDIR)$(prefix)/share/doc/$(PACKAGE) $(srcdir)/%s; \\\n",tmp,docdir,docdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfi\n",tmp);
	g_free(tmp);
	tmp=contenido;
	// now we add instructions to get the glade project file to get instaled in the data directorie if necesary
	if (libs[LLIBGLADE2]=='1') {
		glade_file=pro_glade_file(LOCALE);
		if (glade_file!=NULL) {
			contenido=g_strdup_printf("%s\tif test -f $(srcdir)/%s; then \\\n",tmp,glade_file);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\t\tif test \"x${prefix}\" = \"xNONE\"; then \\\n",tmp);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\t\t\t$(mkinstalldirs) $(DESTDIR)@PACKAGE_DATA_DIR@; \\\n",tmp);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\t\t\t$(INSTALL_DATA) %s $(DESTDIR)@PACKAGE_DATA_DIR@; \\\n",tmp,glade_file);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\t\telse \\\n",tmp);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\t\t\t$(mkinstalldirs) $(DESTDIR)$(prefix)/share/$(PACKAGE); \\\n",tmp);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\t\t\t$(INSTALL_DATA) %s $(DESTDIR)$(prefix)/share/$(PACKAGE); \\\n",tmp,glade_file);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\t\tfi \\\n",tmp);
			g_free(tmp);
			tmp=contenido;
			contenido=g_strdup_printf("%s\tfi\n",tmp);
			g_free(tmp);
			tmp=contenido;
		}
		g_free(glade_file);
	}
	
	// here we add instructions to include de pixmaps and data directories in the distribution
	contenido=g_strdup_printf("%s\ndist-hook:\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfunction strlen_diasce {\\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\teval echo \"\\$${#$${1}}\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t}; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfunction es_cvs_diasce {\\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\ttemporal=$$1; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tlongitud=\"$$(strlen_diasce temporal)\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tlet longitud=longitud-4; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tcadena=$${temporal:longitud}; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tif [ \"x$$cadena\" = \"x/CVS\" ] ; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\treturn 0; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\telse \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\treturn 1; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfi; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t}; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfunction subdirs_diasce {\\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\ttemporal=$$3; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tlongitud=\"$$(strlen_diasce temporal)\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfor doc in $$1/*; do \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tif test -f $$doc; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tdestino=\"$$2$${1:longitud}\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tcp -p $$doc $$destino; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfi; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tif test -d $$doc; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tif ! (es_cvs_diasce $$doc); then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\tdestino=\"$$2$${doc:longitud}\"; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\t$(mkinstalldirs) $$destino; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\t\tsubdirs_diasce $$doc $$2 $$3; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfi \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tdone; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t}; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	// first the pixmaps directorie
	contenido=g_strdup_printf("%s\tif test -d %s; then \\\n",tmp,pixdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tmkdir $(distdir)/%s; \\\n",tmp,pixdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfor pixmap in %s/*; do \\\n",tmp,pixdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tif test -f $$pixmap; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tcp -p $$pixmap $(distdir)/%s; \\\n",tmp,pixdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfi \\\n\t\tdone \\\n\tfi; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	// second the	data directorie
	contenido=g_strdup_printf("%s\tif test -d %s; then \\\n",tmp,datadir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tmkdir $(distdir)/%s; \\\n",tmp,datadir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tfor data in %s/*; do \\\n",tmp,datadir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tif test -f $$data; then \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\t\tcp -p $$data $(distdir)/%s; \\\n",tmp,datadir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tfi \\\n\t\tdone \\\n\tfi; \\\n",tmp);
	g_free(tmp);
	tmp=contenido;
	// third the	doc directorie
	contenido=g_strdup_printf("%s\tif test -d %s; then \\\n",tmp,docdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\tmkdir $(distdir)/%s; \\\n",tmp,docdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\t\t\tsubdirs_diasce %s $(distdir)/%s %s; \\\n",tmp,docdir,docdir,docdir);
	g_free(tmp);
	tmp=contenido;
	contenido=g_strdup_printf("%s\tfi\n",tmp);
	g_free(tmp);
	tmp=contenido;
	g_free(pixdir);
	g_free(datadir);
	g_free(docdir);
	
	nombre=pro_nombre_completo_archivo("Makefile.am",FALSE, LOCALE);
	archivo=fopen(nombre,"w");
	fwrite(contenido,strlen(contenido),1,archivo);
	fclose(archivo);
	g_free(nombre);
	g_free(contenido);
	g_free(libs);
	g_free(srcdir);
	autoconfiguracion=autoconfiguracion | AUTO_MAKE;
	
	DEBUG_MSG(<-aut_crear_makefile);
}

/*******************************************************************************
 Esta funcion genera el archivo profiles.in que se encuentra en la carpeta po
 *******************************************************************************/
void aut_crear_potfiles_in(void)
{
	FILE *archivo;
	gchar *nombre;
	gchar *contenido,*tmp,*siguiente;
	xmlNodePtr nodo;
	gchar *libs;
	gchar *srcdir;
	
	DEBUG_MSG(->aut_crear_potfiles_in);
	libs=pro_librerias_lincado();
	if (libs[LGETTEXT]=='0') {
		g_free(libs);
		DEBUG_MSG(<-aut_crear_potfiles_in GETTEXT off);
		return;
	}
	
	contenido=g_strdup_printf("# List of source files containing translable strings.\n\n");
	tmp=contenido;
	
	srcdir=pro_srcdir(LOCALE);
	if ((libs[LLIBGLADE2]=='1') && (libs[LGETTEXT]=='1')) {
		contenido=g_strdup_printf("%s%s/translatable_strings_file.c\n",tmp,srcdir);
		g_free(tmp);
		tmp=contenido;
	}
	
	nodo=NULL;
	do {
		siguiente=pro_fuentes(&nodo, LOCALE);
		if (siguiente!=NULL) {
			contenido=g_strdup_printf("%s%s/%s\n",tmp,srcdir,siguiente);
			g_free(siguiente);
			g_free(tmp);
			tmp=contenido;
		}
	} while (siguiente!=NULL);
	g_free(srcdir);

	nombre=pro_prodir(LOCALE);
	tmp=nombre;
	nombre=g_strdup_printf("%s/po",tmp);
	mkdir(nombre, S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
	g_free(nombre);
	nombre=g_strdup_printf("%s/po/POTFILES.in",tmp);
	g_free(tmp);
	archivo=fopen(nombre,"w");
	fwrite(contenido,strlen(contenido),1,archivo);
	fclose(archivo);
	g_free(nombre);
	g_free(contenido);
	g_free(libs);
	DEBUG_MSG(<-aut_crear_potfiles_in);
}

/*******************************************************************************
 Esta funcion genera el archivo acconfig.h
 *******************************************************************************/
void aut_crear_acconfig_h(void)
{
	gchar *nombre;
	
	DEBUG_MSG(->aut_crear_acconfig_h);

	nombre=pro_nombre_completo_archivo("acconfig",TRUE, LOCALE);
	g_free(nombre);
	if (gen_existe_fichero("acconfig.h")) {
		remove("acconfig.h");
	}
	
	autoconfiguracion=autoconfiguracion | AUTO_HEADER;
	
	DEBUG_MSG(<-aut_crear_acconfig_h);
}
