// Encoding: ISO-8859-15
/*
 * diasce
 * Copyright (C) 2003  Ander Lozano Prez
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Ander Lozano Prez
 * ander1@wanadoo.es
 */

#include "main.h"

//*******************************************************************

void dnd_init(void)
{
	dnd_file_tree_to_textview_init(NULL);
}

void dnd_file_tree_to_textview_init(GtkWidget *text_view)
{
	GtkWidget *widget;
	GtkTargetEntry targets[1];
	GtkTargetList *list;
	
	targets[0].target=g_strdup("diasce_file_view");
	targets[0].flags=GTK_TARGET_SAME_APP;
	targets[0].info=1;

	if (text_view==NULL) {
		widget=glade_xml_get_widget(david_ventana,"archivos_arbol");
		gtk_drag_source_set(widget,GDK_BUTTON2_MASK | GDK_BUTTON1_MASK,targets,1,GDK_ACTION_COPY);
	}
	
	if (text_view==NULL) {
		widget=GTK_WIDGET(edit_editor);
	} else {
		widget=text_view;
	}
	list=gtk_drag_dest_get_target_list(widget);
	gtk_target_list_add_table(list,targets,1);
	gtk_drag_dest_set_target_list(widget,list);
	
}

void dnd_textview_drag_drop(GtkWidget *widget, GdkDragContext *dc, gint x, gint y, GtkSelectionData *selection_data, guint info, guint t, gpointer data)
{
	GtkWidget *source,*tree_view;
	GtkTreeSelection *selection;
	GtkTreeIter iter;
	GtkTreeModel *model;
	GtkNotebook *notebook;
	GtkWidget *editor_texto;
	t_lista_archivos *nodo;
	gchar *nombre;
	
	source=gtk_drag_get_source_widget(dc);
	tree_view=glade_xml_get_widget(david_ventana,"archivos_arbol");
	if (source==tree_view) {
		selection=gtk_tree_view_get_selection(GTK_TREE_VIEW(tree_view));
		if (gtk_tree_selection_get_selected(selection,&model,&iter)) {
			gtk_tree_model_get(model,&iter,COL_NOMBRE,&nombre,-1);
			if (pro_existe_archivo(nombre)) {
				nodo=raiz_lista_archivos;
				while (g_strcasecmp(nodo->nombre,nombre)) {
					nodo=nodo->siguiente;
				}

				notebook=GTK_NOTEBOOK(glade_xml_get_widget(david_ventana,"archivos_notebook"));
				
				edit_actual=nodo;
				if (nodo->pestana!=-1) {
					gtk_notebook_set_page(notebook,nodo->pestana);
					edit_actualizar_fila();
					buscar_indice=0;
					buscar_terminado=FALSE;
					edit_abriendo_llave=FALSE;
					edit_mensaje("");
					g_free(nombre);
					if (nodo->pestana==0) {
						on_mover_a_pestana_nueva1_activate(NULL,NULL);
					}
					return;
				}
				
				editor_texto=edit_create_page(edit_actual->nombre);
				
				edit_actual->editor=GTK_SOURCE_VIEW(editor_texto);
				edit_actual->pestana=-1;
				edit_ver(edit_actual->nombre);
				edit_actual->pestana=edit_total_pestanas;
				gtk_notebook_set_page(notebook,edit_total_pestanas);	
			}
			g_free(nombre);			
		}
	}
}
