// Encoding: ISO-8859-15
/*
 * diasce
 * Copyright (C) 2002  Ander Lozano Prez
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Ander Lozano Prez
 * ander1@wanadoo.es
 */

#include "main.h"

void ext_inicializar(void)
{
	ext_crear_ventana();
	ext_lista_pestanas=NULL;
}

void ext_crear_ventana(void)
{
	GtkWidget *vbox,*button,*toolbar,*icono,*entry;
	
	ext_ventana=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(ext_ventana),_("External files"));
	g_signal_connect(G_OBJECT(ext_ventana),"delete_event",G_CALLBACK(ext_cerrar_ventana),NULL);

	vbox=gtk_vbox_new(FALSE,0);
	
	toolbar=gtk_toolbar_new();
	gtk_widget_show(toolbar);
	gtk_box_pack_start(GTK_BOX(vbox),toolbar,FALSE,FALSE,0);
	
	// here we create the open button
	button=gtk_button_new();
	g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(ext_open_button_clicked),NULL);
	gtk_widget_show(button);
	gtk_button_set_relief(GTK_BUTTON(button),GTK_RELIEF_NONE);
	gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),button,_("Open an external file in a new tab"),NULL);
	icono=gtk_image_new_from_stock(GTK_STOCK_OPEN,GTK_ICON_SIZE_LARGE_TOOLBAR);
	gtk_widget_show(icono);
	gtk_container_add(GTK_CONTAINER(button),icono);
	
	// here we create the save button
	button=gtk_button_new();
	g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(ext_save_button_clicked),NULL);
	gtk_widget_show(button);
	gtk_button_set_relief(GTK_BUTTON(button),GTK_RELIEF_NONE);
	gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),button,_("Saves the current file"),NULL);
	icono=gtk_image_new_from_stock(GTK_STOCK_SAVE,GTK_ICON_SIZE_LARGE_TOOLBAR);
	gtk_widget_show(icono);
	gtk_container_add(GTK_CONTAINER(button),icono);

	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
	
	// now we add a text entry for search
	entry=gtk_entry_new();
	gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),entry,_("Search entry.\nControl+F3 adds the selection to the search entry an makes a forward search.\nF3 makes a forward search.\nShift+F3 makes a backward search."),NULL);
	g_signal_connect (G_OBJECT(entry),"key_press_event",G_CALLBACK(ext_search_entry_key_press_event),NULL);
	gtk_widget_show(entry);
	ext_search_entry=entry;
	
	ext_notebook=gtk_notebook_new();
	g_signal_connect(G_OBJECT(ext_notebook),"switch_page",G_CALLBACK(ext_notebook_switch_page),NULL);
	gtk_notebook_set_scrollable(GTK_NOTEBOOK(ext_notebook),TRUE);
	gtk_box_pack_start(GTK_BOX(vbox),ext_notebook,TRUE,TRUE,0);
	
	gtk_container_add(GTK_CONTAINER(ext_ventana),vbox);
}

GtkSourceView *ext_crear_pestana(gchar *etiqueta)
{
	GtkBox *box;
	GtkWidget *widget,*icono;
	GtkWidget *source_view;
	t_ext_lista_pestanas *nueva,*ultima;
	
	nueva=g_malloc(sizeof(t_ext_lista_pestanas));
	nueva->siguiente=NULL;
	box=GTK_BOX(gtk_hbox_new(FALSE,3));
	widget=gtk_label_new(etiqueta);
	gtk_widget_show(widget);
	gtk_box_pack_start(box,widget,FALSE,FALSE,0);
	widget=gtk_button_new();
	g_signal_connect(G_OBJECT(widget),"clicked",G_CALLBACK(ext_destruir_pestana),(gpointer)nueva);
	gtk_widget_show(widget);
	gtk_widget_set_size_request(widget,15,15);
	gtk_button_set_relief(GTK_BUTTON(widget),GTK_RELIEF_NONE);
	gtk_box_pack_start(box,widget,FALSE,FALSE,0);
	icono=gtk_image_new_from_stock(GTK_STOCK_CLOSE,GTK_ICON_SIZE_MENU);
	gtk_widget_show(icono);
	gtk_container_add(GTK_CONTAINER(widget),icono);

	source_view=editor_texto_new(NULL,NULL,NULL,1,0);
	g_signal_connect (G_OBJECT (source_view), "key_press_event",G_CALLBACK(ext_view_key_press_event),NULL);
	nueva->view=source_view;
	widget=gtk_scrolled_window_new(NULL,NULL);
	gtk_container_add(GTK_CONTAINER(widget),source_view);
	gtk_source_view_set_tab_stop(GTK_SOURCE_VIEW(source_view),preferencias.tabulador);
	gtk_widget_show(source_view);
	gtk_widget_show(widget);
	gtk_notebook_append_page(GTK_NOTEBOOK(ext_notebook),widget,GTK_WIDGET(box));
	nueva->tab=gtk_notebook_page_num(GTK_NOTEBOOK(ext_notebook),widget);
	
	if (ext_lista_pestanas==NULL) {
		ext_lista_pestanas=nueva;
	} else {
		ultima=ext_lista_pestanas;
		while (ultima->siguiente!=NULL) {
			ultima=ultima->siguiente;
		}
		ultima->siguiente=nueva;
	}
	
	return GTK_SOURCE_VIEW(source_view);
}

void ext_destruir_pestana(GtkButton *button,gpointer user_data)
{
	t_ext_lista_pestanas *pulsada,*anterior;
	gchar *message;
	gint page;
	
	page=gtk_notebook_get_current_page(GTK_NOTEBOOK(ext_notebook));
	
	pulsada=(t_ext_lista_pestanas *)user_data;
	if ((preferencias.close) || (page==pulsada->tab)) {
		if (gtk_text_buffer_get_modified(GTK_TEXT_BUFFER(pulsada->buffer))) {
			message=g_strdup_printf(_("%s has been modified, and changes have not been saved. Do you still what to close it?"),pulsada->nombre_utf8);
			if (!gen_ventana_confirmacion(message,GTK_BUTTONS_YES_NO)) {
				gtk_notebook_set_current_page(GTK_NOTEBOOK(ext_notebook),pulsada->tab);
				g_free(message);
				return;
			}
			g_free(message);
		}
		anterior=pulsada->siguiente;
		while (anterior!=NULL) {
			anterior->tab=(anterior->tab)-1;
			anterior=anterior->siguiente;
		}
		anterior=ext_lista_pestanas;
		while ((anterior!=NULL) && (anterior->siguiente!=pulsada)) {
			anterior=anterior->siguiente;
		}
		
		gtk_notebook_remove_page(GTK_NOTEBOOK(ext_notebook),pulsada->tab);
		if (anterior!=NULL) {
			anterior->siguiente=pulsada->siguiente;
		} else {
			ext_lista_pestanas=pulsada->siguiente;
		}
		g_free(pulsada->nombre);
		g_free(pulsada);
		if (gtk_notebook_get_current_page(GTK_NOTEBOOK(ext_notebook))==-1) {
			gen_cerrar_ventana(ext_ventana);
		}
	} else {
		gtk_notebook_set_current_page(GTK_NOTEBOOK(ext_notebook),pulsada->tab);
	}
}

void ext_abrir(gchar **archivos)
{
	gint cont,cont2;
	GtkSourceBuffer *buffer;
	GtkSourceView *view;
	gint tipo;
	G_CONST_RETURN char *locale;
	gchar *nombre_locale;
	gsize read, written;
	t_ext_lista_pestanas *ultima;
	struct stat status;
	gchar *message;
	GError *error;
	
	DEBUG_MSG(->ext_abrir);
	
	error=NULL;
	gtk_widget_show_all(ext_ventana);
	cont=0;
	while (archivos[cont]!=NULL) {
		for (cont2=0;archivos[cont][cont2]!=0;cont2++);
		for (;archivos[cont][cont2]!='/';cont2--);
		cont2++;
		view=ext_crear_pestana(archivos[cont]+cont2);
		buffer=gtk_source_buffer_new(NULL);
		tipo=gen_tipo_archivo(archivos[cont]+cont2);
		if ((tipo==1) || (tipo==2)) {
			edit_aplicar_reglas_coloreado(buffer);
		} else {
			gtk_source_buffer_set_highlight(buffer,FALSE);
		}
		ultima=ext_lista_pestanas;
		while (ultima->siguiente!=NULL) {
			ultima=ultima->siguiente;
		}
		ultima->tipo=tipo;
		ultima->buffer=buffer;
		g_get_charset(&locale);
		nombre_locale=g_locale_from_utf8(archivos[cont], -1, &read, &written, NULL);
		stat(nombre_locale,&status);
		ultima->nombre_utf8=g_strdup(archivos[cont]);
		ultima->nombre=g_strdup(nombre_locale);
		ultima->mtime=status.st_mtime;
		if (access(nombre_locale,W_OK)!=0) {
			message=g_strdup_printf(_("You don't have permision to write on:\n%s\n\nThe file will be openned in read only mode."),archivos[cont]);
			gen_ventana_mensaje(message,GTK_MESSAGE_INFO);
			g_free(message);
			gtk_text_view_set_editable(GTK_TEXT_VIEW(view),FALSE);
		} else {
			gtk_text_view_set_editable(GTK_TEXT_VIEW(view),TRUE);
		}
		gtk_source_buffer_load_with_character_encoding(buffer,nombre_locale,locale,&error);
		g_clear_error(&error);
		gtk_text_view_set_buffer(GTK_TEXT_VIEW(view),GTK_TEXT_BUFFER(buffer));
		g_free(nombre_locale);
		cont++;
	}
	DEBUG_MSG(<-ext_abrir);
}

gboolean ext_cerrar_ventana(GtkWidget *widget,GdkEvent *event,gpointer user_data)
{
	gen_cerrar_ventana(widget);
  	return TRUE;
}

void ext_open_button_clicked(GtkButton *button,gpointer user_data)
{
	GtkWidget *ventana;
	
	chdir(preferencias.directorio);
	archivos_ventana = glade_xml_new(GLADE_PROJECT,"archivos_ventana",NULL);
	glade_xml_signal_autoconnect(archivos_ventana);
	ventana=glade_xml_get_widget(archivos_ventana,"archivos_ventana");
	gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(ventana));
	gtk_file_selection_set_select_multiple(GTK_FILE_SELECTION(ventana),TRUE);
	estado_archivos_ventana=EXTERNOS_ABRIR;
	gtk_widget_show(ventana);
}

void ext_save_button_clicked(GtkButton *button,gpointer user_data)
{
	G_CONST_RETURN char *locale;
	gint page;
	t_ext_lista_pestanas *current;
	struct stat status;
	gchar *message;
	GError *error;
	
	error=NULL;
	page=gtk_notebook_get_current_page(GTK_NOTEBOOK(ext_notebook));
	current=ext_lista_pestanas;
	while ((current!=NULL) && (current->tab!=page)) {
		current=current->siguiente;
	}
	g_get_charset(&locale);
	stat(current->nombre,&status);
	if (status.st_mtime!=current->mtime) {
		message=g_strdup_printf(_("%s has been modified by another program. Do you want to over write it?"),current->nombre_utf8);
		if (!gen_ventana_confirmacion(message,GTK_BUTTONS_YES_NO)) {
			g_free(message);
			return;
		}
		g_free(message);
	}
	gtk_source_buffer_save_with_character_encoding(current->buffer,current->nombre,locale,&error);
	g_clear_error(&error);
	gtk_text_buffer_set_modified(GTK_TEXT_BUFFER(current->buffer),FALSE);
	stat(current->nombre,&status);
	current->mtime=status.st_mtime;
}

void ext_notebook_switch_page(GtkNotebook *notebook,GtkNotebookPage *page,gint page_num,gpointer user_data)
{
	t_ext_lista_pestanas *selected;
	struct stat status;
	gchar *message;
	GtkSourceBuffer *buffer;
	G_CONST_RETURN char *locale;
	GError *error;
	
	error=NULL;
	selected=ext_lista_pestanas;
	while ((selected!=NULL) && (selected->tab!=page_num)) {
		selected=selected->siguiente;
	}
	if (selected==NULL) return;

	stat(selected->nombre,&status);
	if (selected->mtime!=status.st_mtime) {
		message=g_strdup_printf(_("%s has been modified by another program, do you want to reload it?"),selected->nombre_utf8);
		if (gen_ventana_confirmacion(message,GTK_BUTTONS_YES_NO)) {
			selected->mtime=status.st_mtime;
			buffer=gtk_source_buffer_new(NULL);
			if ((selected->tipo==1) || (selected->tipo==2)) {
				edit_aplicar_reglas_coloreado(buffer);
			} else {
				gtk_source_buffer_set_highlight(buffer,FALSE);
			}
			g_get_charset(&locale);
			gtk_source_buffer_load_with_character_encoding(buffer,selected->nombre,locale,&error);
			g_clear_error(&error);
			gtk_text_view_set_buffer(GTK_TEXT_VIEW(selected->view),GTK_TEXT_BUFFER(buffer));
			gtk_widget_destroy(GTK_WIDGET(selected->buffer));
			selected->buffer=buffer;
		}
		g_free(message);
	}
}

gboolean ext_view_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data)
{
	gboolean control;
	gboolean shift;
	GtkTextIter inicio,fin;
	gchar *cadena;
	GtkTextMark *cursor_position_mark,*selection_mark;
	GtkTextIter cursor_position_iter;
	gboolean text_found;
	GtkTextBuffer *buffer;
	
	control=event->state & GDK_CONTROL_MASK;
	shift=event->state & GDK_SHIFT_MASK;
	
	buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget));

	switch (event->keyval) {
		case GDK_F3:
			if (control) {
				if (gtk_text_buffer_get_selection_bounds(buffer,&inicio,&fin)) {
					cadena=gtk_text_buffer_get_text(buffer,&inicio,&fin,TRUE);
					gtk_entry_set_text(GTK_ENTRY(ext_search_entry),cadena);
					g_free(cadena);
				}
			}
			cursor_position_mark = gtk_text_buffer_get_insert (buffer);
			gtk_text_buffer_get_iter_at_mark(buffer, &cursor_position_iter, cursor_position_mark);
			cadena=gtk_editable_get_chars(GTK_EDITABLE(ext_search_entry),0,-1);
			if ((cadena==NULL) || (cadena[0]==0)) {
				return TRUE;
			}
			text_found=FALSE;
			if (shift) {
				text_found=buscar_cadena_backward(buffer,NULL,&cursor_position_iter,cadena,&inicio,&fin,0);
				if (!text_found) {
					text_found=buscar_cadena_backward(buffer,NULL,NULL,cadena,&inicio,&fin,0);
				}
			} else {
				text_found=buscar_cadena_forward(buffer,&cursor_position_iter,NULL,cadena,&inicio,&fin,0);
				if (!text_found) {
					text_found=buscar_cadena_forward(buffer,NULL,NULL,cadena,&inicio,&fin,0);
				}
			}
			g_free(cadena);
			if (text_found) {
				gtk_text_buffer_place_cursor(buffer,&fin);
				selection_mark = gtk_text_buffer_get_selection_bound(buffer);
				gtk_text_buffer_move_mark(buffer, selection_mark, &inicio);
				gtk_text_view_scroll_to_mark(GTK_TEXT_VIEW(widget), selection_mark, 0, TRUE, 1,0.5);
			}
			return TRUE;
			break;
	}
	return FALSE;
}

gboolean ext_search_entry_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data)
{
	t_ext_lista_pestanas *selected;
	gint page_num;
	
	if ((event->keyval==GDK_Return) || (event->keyval==GDK_F3)) {
		page_num=gtk_notebook_get_current_page(GTK_NOTEBOOK(ext_notebook));
		selected=ext_lista_pestanas;
		while ((selected!=NULL) && (selected->tab!=page_num)) {
			selected=selected->siguiente;
		}
		event->keyval=GDK_F3;
		ext_view_key_press_event(GTK_WIDGET(selected->view),event,NULL);
		return TRUE;
	}
	return FALSE;
}
