// Encoding: ISO-8859-15
/*
 * diasce
 * Copyright (C) 2002  Ander Lozano Prez
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Ander Lozano Prez
 * ander1@wanadoo.es
 */

#include "main.h"

//*******************************************************************************************************************

typedef struct s_ext_lista_pestanas {
	gchar *nombre; // file name in locale
	gchar *nombre_utf8; // file name in UTF8
	gint tab;
	GtkWidget *view;
	GtkSourceBuffer *buffer;
	gint tipo;
	time_t mtime; //last modification time
	struct s_ext_lista_pestanas *siguiente;
} t_ext_lista_pestanas;

//*******************************************************************************************************************

GtkWidget *ext_ventana;
GtkWidget *ext_notebook;
GtkWidget *ext_search_entry;
t_ext_lista_pestanas *ext_lista_pestanas;

//*******************************************************************************************************************

void ext_inicializar(void);

void ext_crear_ventana(void);

GtkSourceView *ext_crear_pestana(gchar *etiqueta);

void ext_destruir_pestana(GtkButton *button,gpointer user_data);

void ext_abrir(gchar **archivos);

gboolean ext_cerrar_ventana(GtkWidget *widget,GdkEvent *event,gpointer user_data);

void ext_open_button_clicked(GtkButton *button,gpointer user_data);

void ext_save_button_clicked(GtkButton *button,gpointer user_data);

void ext_notebook_switch_page(GtkNotebook *notebook,GtkNotebookPage *page,gint page_num,gpointer user_data);

gboolean ext_view_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data);

gboolean ext_search_entry_key_press_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data);
