// Encoding: ISO-8859-15
/*
 * diasce
 * Copyright (C) 2003  Ander Lozano Prez
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Ander Lozano Prez
 * ander1@wanadoo.es
 */

#include "main.h"

//*******************************************************************

void print_boton_pulsado(void)
{
	gint respuesta;
	
	respuesta=gtk_dialog_run(GTK_DIALOG(print_dialog));
	switch (respuesta) {
		case GNOME_PRINT_DIALOG_RESPONSE_CANCEL:
			gnome_print_job_close(print_job);
			break;
		case GNOME_PRINT_DIALOG_RESPONSE_PRINT:
			print_construir_paginas();
			gnome_print_job_close(print_job);
			gnome_print_job_print(print_job);
			break;
		case GNOME_PRINT_DIALOG_RESPONSE_PREVIEW:
			print_construir_paginas();
			gnome_print_job_close(print_job);
			print_preview=gnome_print_job_preview_new(print_job,_("Preview"));
			gtk_widget_show(print_preview);
			break;
	}
	gtk_widget_destroy(GTK_WIDGET(print_dialog));
}

void print_construir_paginas(void)
{
	GnomeFont *font;
	gchar *texto;
	GtkTextIter inicio,tmp,fin;
	gdouble ancho,alto;
	gdouble x,y;
	gboolean fin_texto;
	gint start_line,end_line;
	gint range_page;
	gint cont,offset;
	gint pagina;
	gchar *pie,*cabecera;
	GtkTextBuffer *buffer;
	gchar *proyecto,*version;
	struct tm *fecha;
	time_t tiempo;
	GSList *tags;
	PangoStyle style;
	gint weight;
	GValue *value;
	
	x=0;
	y=0;
	
	buffer=GTK_TEXT_BUFFER(edit_actual->datos);
	proyecto=pro_nombre(UTF8);
	version=pro_version();
	
	time(&tiempo);
	fecha=localtime(&tiempo);
	
	gnome_print_job_get_page_size_from_config(print_config,&ancho,&alto);
	range_page=gnome_print_dialog_get_range_page(print_dialog,&start_line,&end_line);
	start_line--;
	end_line--;
	
	switch (range_page) {
		case GNOME_PRINT_RANGE_ALL:
			gtk_text_buffer_get_bounds(buffer,&inicio,&fin);
			x=MR;
			y=alto-MT-LH;
			break;
		case GNOME_PRINT_RANGE_RANGE:
			gtk_text_buffer_get_iter_at_line(buffer,&inicio,start_line);
			gtk_text_buffer_get_iter_at_line(buffer,&fin,end_line);
			if (gtk_text_iter_forward_line(&fin)) {
				gtk_text_iter_backward_char(&fin);
			}
			x=MR;
			y=alto-MT-LH;
			break;
		case GNOME_PRINT_RANGE_SELECTION:
			gtk_text_buffer_get_selection_bounds(buffer,&inicio,&fin);
			offset=gtk_text_iter_get_line_offset(&inicio);
			x=MR;
			y=alto-MT-LH;
			for (cont=0;cont<offset;cont++) {
				x+=CW;
				if ((x>=ancho-MR-CW) && (y>MB)) {
					x=MR;
					y-=LH;
				}
				if (y<=MB) {
					x=MR;
					y=alto-MT-LH;
				}
			}
			break;
		// the next to cases will never hapen, they are here not to get the warnings.
		case GNOME_PRINT_RANGE_CURRENT:
		case GNOME_PRINT_RANGE_SELECTION_UNSENSITIVE:
			break;
	}
	
	tmp=inicio;
	fin_texto=!gtk_text_iter_forward_char(&tmp);
	if (fin_texto) {
		fin_texto=(gtk_text_iter_get_offset(&inicio)==gtk_text_iter_get_offset(&tmp));
	}
	
	pagina=0;
	while (!fin_texto) {
	
		// The fonts that will be corectly represented are
		// Courier
		// Courier Bold
		// Courier Oblique
		// Courier Bold Oblique
	
		gnome_print_beginpage(print_context,NULL);
		pagina++;

		font=gnome_font_find_closest("Courier",8);
		gnome_print_setfont(print_context,font);
		cabecera=g_strdup_printf("%s - %s %s - %i/%i/%i",edit_actual->nombre,proyecto,version,fecha->tm_mday,(fecha->tm_mon)+1,(fecha->tm_year)+1900);
		gnome_print_moveto(print_context,CABECERA_X,alto-CABECERA_Y);
		gnome_print_show(print_context,cabecera);
		g_free(cabecera);
	
		while ((y>MB) && (!fin_texto)) {
			GValue val1 = { 0, };
			GValue val2 = { 0, };

			tags=gtk_text_iter_get_tags(&inicio);
			if (tags==NULL) {
				if (preferencias.cursiba_nada) {
					style=PANGO_STYLE_ITALIC;
				} else {
					style=PANGO_STYLE_NORMAL;
				}
				if (preferencias.negrita_nada) {
					weight=PANGO_WEIGHT_BOLD;
				} else {
					weight=PANGO_WEIGHT_NORMAL;
				}
			} else {
				value = &val1;
				g_value_init(value,G_TYPE_INT);
				g_object_get_property(G_OBJECT(tags->data),"weight",value);
				weight=g_value_get_int(value);
				value = &val2;
				g_value_init(value,PANGO_TYPE_STYLE);
				g_object_get_property(G_OBJECT(tags->data),"style",value);
				style=g_value_get_enum(value);
				g_slist_free(tags);
			}
			
			if ((style==PANGO_STYLE_NORMAL) && (weight==PANGO_WEIGHT_NORMAL)) {
				font=gnome_font_find_closest("Courier",12);
				gnome_print_setfont(print_context,font);
			} else {
				if ((style==PANGO_STYLE_NORMAL) && (weight==PANGO_WEIGHT_BOLD)) {
					font=gnome_font_find_closest("Courier Bold",12);
					gnome_print_setfont(print_context,font);
				} else {
					if ((style==PANGO_STYLE_ITALIC) && (weight==PANGO_WEIGHT_NORMAL)) {
						font=gnome_font_find_closest("Courier Oblique",12);
						gnome_print_setfont(print_context,font);
					} else {
						font=gnome_font_find_closest("Courier Bold Oblique",12);
						gnome_print_setfont(print_context,font);
					}
				}
			}

			gnome_print_moveto(print_context,x,y);
			texto=gtk_text_buffer_get_text(buffer,&inicio,&tmp,FALSE);
			switch (texto[0]) {
				case '\n':
					x=MR;
					y-=LH;
					break;
				case '\t':
					x+=CW*preferencias.tabulador;
					break;
				case ' ':
					x+=CW;
					break;
				default:
					gnome_print_show(print_context,texto);
					x+=CW;
					break;
			}
			gtk_text_iter_forward_char(&inicio);
			fin_texto=(gtk_text_iter_get_offset(&inicio)==gtk_text_iter_get_offset(&fin));
			gtk_text_iter_forward_char(&tmp);
			if ((x>=ancho-MR-CW) && (y>MB)) {
				x=MR;
				y-=LH;
			}
			g_free(texto);
		}
		x=MR;
		y=alto-MT-LH;

		font=gnome_font_find_closest("Courier",8);
		gnome_print_setfont(print_context,font);
		pie=g_strdup_printf(_("Page: %i"),pagina);
		gnome_print_moveto(print_context,ancho-PIE_X-PIE_CW*g_utf8_strlen(pie,-1),PIE_Y);
		gnome_print_show(print_context,pie);
		g_free(pie);
		
		gnome_print_showpage(print_context);
	}
	
	g_free(proyecto);
	g_free(version);
}
